// TestSDKDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestSDK.h"
#include "TestSDKDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define  TIMERID	1000
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTestSDKDlg dialog




CTestSDKDlg::CTestSDKDlg(CWnd* pParent /*=NULL*/)
: CDialog(CTestSDKDlg::IDD, pParent)
{
	setTime = 5;//according to yourself needing to change this value.
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestSDKDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CTestSDKDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BTN_GETTEMP, &CTestSDKDlg::OnBnClickedBtnGettemp)
	ON_BN_CLICKED(IDC_BTN_GETSMARTFAN, &CTestSDKDlg::OnBnClickedBtnGetsmartfan)
	ON_BN_CLICKED(IDC_BTN_BEEP, &CTestSDKDlg::OnBnClickedBtnBeep)
	ON_BN_CLICKED(IDC_BTN_GETFAN, &CTestSDKDlg::OnBnClickedBtnGetfan)
	ON_BN_CLICKED(IDC_BTN_GETDIO, &CTestSDKDlg::OnBnClickedBtnGetdio)
	ON_BN_CLICKED(IDC_BTN_WDT, &CTestSDKDlg::OnBnClickedBtnWdt)
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BTN_POWEROFF, &CTestSDKDlg::OnBnClickedBtnPoweroff)
	ON_BN_CLICKED(IDC_BTN_REBOOT, &CTestSDKDlg::OnBnClickedBtnReboot)
	ON_BN_CLICKED(IDC_BTN_POWERON, &CTestSDKDlg::OnBnClickedBtnPoweron)
END_MESSAGE_MAP()


// CTestSDKDlg message handlers

BOOL CTestSDKDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	ISMMSDK_ERROR_CODE res = WMI_ERRR_CODE_SUCCESS;

	//local login
	if ( WMI_ERRR_CODE_SUCCESS != (res = WmiInit()) )
	{
		MessageBox(L"WmiInit fail.");
		SendMessage(WM_CLOSE,NULL,NULL);
		return FALSE;
	}
	else
	{
		GetDlgItem(IDC_BTN_POWEROFF)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_BTN_REBOOT)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_BTN_POWERON)->ShowWindow(SW_HIDE);
	}
/*
	//remote login
	//ûadministratorһЩȨ趨.
	if ( WMI_ERRR_CODE_SUCCESS != (res = WmiInit(L"10.10.10.10",L"Administrator",L"password",TRUE)) )
	{
		MessageBox(L"WmiInit fail.");
		SendMessage(WM_CLOSE,NULL,NULL);
		return FALSE;
	}
	else
	{
		SetTimer(TIMERID+1,1*60*1000,NULL);//ÿһʱWMI root/cimv2namespaceһ
		GetDlgItem(IDC_BTN_POWEROFF)->ShowWindow(SW_NORMAL);
		GetDlgItem(IDC_BTN_REBOOT)->ShowWindow(SW_NORMAL);
		GetDlgItem(IDC_BTN_POWERON)->ShowWindow(SW_NORMAL);
	}
*/
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestSDKDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestSDKDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestSDKDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CTestSDKDlg::OnBnClickedBtnGettemp()
{
	// TODO: Add your control notification handler code here

	ZeroMemory(&wmi_value,sizeof(WMI_VALUE));
	ZeroMemory(&wmi_obid,sizeof(WMI_OBID));
	ZeroMemory(&wmi_data,sizeof(WMI_DATA));
	ISMMSDK_ERROR_CODE res = WMI_ERRR_CODE_SUCCESS;

	if ( WMI_ERRR_CODE_SUCCESS != (res = GetObjectIDWMI(TEMP,&wmi_obid)) )
	{
		MessageBox(L"GetObjectIDWMI fail.");
		return;
	}
	if ( wmi_obid.IDNum )
	{
		if ( ( WMI_ERRR_CODE_SUCCESS == (res = GetObjectIDInfoWMI(wmi_obid.ID[0],&wmi_data)) ) &&
			( WMI_ERRR_CODE_SUCCESS == (res = GetValueWMI(wmi_obid.ID[0],&wmi_value)) ) )
		{
			CString str;
			str.Format(L"%s HighValue %d LowValue %d,R1 %d,R2 %d,R3 %d,SW %d,STA %x \n\r",wmi_obid.IDString[0],\
				wmi_data.objectHigh,wmi_data.objectLow,wmi_data.Resver1,wmi_data.Resver2,wmi_data.Resver3,wmi_data.supportWarning,\
				wmi_data.status);
			if(wmi_value.value1 > 0x80)
				str.AppendFormat(L"Value -%d",0x7F-(wmi_value.value1&0x7F));
			else
				str.AppendFormat(L"Value %d",wmi_value.value1);
			MessageBox(str);
		} 
		else
		{
			MessageBox(L"Get information fail.");
			return;
		}
	}
}

void CTestSDKDlg::OnBnClickedBtnGetsmartfan()
{
	// TODO: Add your control notification handler code here
	ZeroMemory(&wmi_value,sizeof(WMI_VALUE));
	ZeroMemory(&wmi_obid,sizeof(WMI_OBID));
	ISMMSDK_ERROR_CODE res = WMI_ERRR_CODE_SUCCESS;

	if ( WMI_ERRR_CODE_SUCCESS != (res = GetObjectIDWMI(SMARTFAN,&wmi_obid)) )
	{
		MessageBox(L"GetObjectIDWMI fail.");
		return;
	}
	if (wmi_obid.IDNum)
	{
		if ( WMI_ERRR_CODE_SUCCESS != (res = GetValueWMI(wmi_obid.ID[0],&wmi_value)) )
		{
			MessageBox(L"GetValueWMI fail.");
			return;
		}
		int SmartFanMode=wmi_value.status&4;
		int SmartFanControl=wmi_value.status&2;
		CString str;
		str.Format(L"%s Control-By %s \r\nMode %s \r\n",wmi_obid.IDString[0],SmartFanControl?L"EC":L"SIO",SmartFanMode?L"Manual":L"Auto");
		if (SmartFanControl)//control by ec
		{
			if (SmartFanMode)//manual
			{
				int val=(wmi_value.status>>16)&0xff;
				if(val)
					val=val*100/0x100+1;
				str.AppendFormat(L"Fan PWM %d",val);
			} 
			else//auto
			{
				str.AppendFormat(L"SmartFan Off %d\r\nSmartFan On %d\r\nSmartFan StartPWM %d\r\nSmartFan Slop %d",wmi_value.value1&0xFF,(wmi_value.value1>>8)&0xFF,(wmi_value.value1>>16)&0xFF,(wmi_value.value1>>24)&0xFF);
			}
		} 
		else//control by sio
		{
			if (SmartFanMode)//manual
			{
				int val=(wmi_value.status>>16)&0xff;
				if(val)
					val=val*100/0x100+1;
				str.AppendFormat(L"Fan PWM %d",val);
			} 
			else//auto
			{
				str.AppendFormat(L"boundary 1ST %d\r\nboundary 2ND %d\r\nboundary 3TH %d\r\nboundary 4TH %d\r\n",wmi_value.value1&0xFF,(wmi_value.value1>>8)&0xFF,(wmi_value.value1>>16)&0xFF,(wmi_value.value1>>24)&0xFF);
				str.AppendFormat(L"speed 1ST %d\r\nspeed 2ND %d\r\nspeed 3TH %d\r\nspeed 4TH %d",wmi_value.value2&0xFF,(wmi_value.value2>>8)&0xFF,(wmi_value.value2>>16)&0xFF,(wmi_value.value2>>24)&0xFF);
			}
		}
		MessageBox(str);
	}
}

void CTestSDKDlg::OnBnClickedBtnBeep()
{
	// TODO: Add your control notification handler code here

	ISMMSDK_ERROR_CODE res = WMI_ERRR_CODE_SUCCESS;
	if ( WMI_ERRR_CODE_SUCCESS != (res = BeepWMI()) )
	{
		MessageBox(L"BeepWMI fail.");
		return;
	}
}

void CTestSDKDlg::OnBnClickedBtnGetfan()
{
	// TODO: Add your control notification handler code here

	ZeroMemory(&wmi_value,sizeof(WMI_VALUE));
	ZeroMemory(&wmi_obid,sizeof(WMI_OBID));
	ZeroMemory(&wmi_data,sizeof(WMI_DATA));
	ISMMSDK_ERROR_CODE res = WMI_ERRR_CODE_SUCCESS;

	if ( WMI_ERRR_CODE_SUCCESS != (res = GetObjectIDWMI(FAN,&wmi_obid)) )
	{
		MessageBox(L"GetObjectIDWMI fail.");
		return;
	}
	if (wmi_obid.IDNum)
	{
		if ( ( WMI_ERRR_CODE_SUCCESS == (res = GetObjectIDInfoWMI(wmi_obid.ID[0],&wmi_data)) ) &&
			( WMI_ERRR_CODE_SUCCESS == (res = GetValueWMI(wmi_obid.ID[0],&wmi_value)) ) )
		{
			CString str;
			str.Format(L"%s HighValue %d LowValue %d,R1 %d,R2 %d,R3 %d,SW %d,STA %x \n\rvalue %d",wmi_obid.IDString[0],\
				wmi_data.objectHigh,wmi_data.objectLow,wmi_data.Resver1,wmi_data.Resver2,wmi_data.Resver3,wmi_data.supportWarning,\
				wmi_data.status,wmi_value.value1);
			MessageBox(str);
		} 
		else
		{
			MessageBox(L"Get information fail.");
			return;
		}
	}
}

void CTestSDKDlg::OnBnClickedBtnGetdio()
{
	// TODO: Add your control notification handler code here

	DWORD value=0;
	CString str;
	ZeroMemory(&wmi_value,sizeof(WMI_VALUE));
	ISMMSDK_ERROR_CODE res = WMI_ERRR_CODE_SUCCESS;

	// read
	if ( WMI_ERRR_CODE_SUCCESS == (res = SetDIOWMI(value,&wmi_value)) )
	{
		if ( 0xFFFFFFFF == wmi_value.status )
		{
			MessageBox(L"not support.");
			return;
		}
		str.Format(L"InputStatus %x\r\ncountofDIO %d\r\nOutputStatus %x \r\ncountofDIO %d",wmi_value.value1&(0xFFFFFF),(wmi_value.value1>>25)&0xFF,wmi_value.value2&(0xFFFFFF),(wmi_value.value2>>25)&0xFF);
		MessageBox(str);
	} 
	else
	{
		MessageBox(L"read value fail.");
		return;
	}

	//write, set out status to high
	value=(1<<24)|0xFFFFFF;
	if ( WMI_ERRR_CODE_SUCCESS != (res = SetDIOWMI(value,&wmi_value)) )
	{
		MessageBox(L"write value fail.");
		return;
	}
	//read,check set value
	value=0;
	if ( WMI_ERRR_CODE_SUCCESS == (res = SetDIOWMI(value,&wmi_value)) )
	{
		str.Format(L"InputStatus %x\r\ncountofDIO %d\r\nOutputStatus %x \r\ncountofDIO %d",wmi_value.value1&(0xFFFFFF),(wmi_value.value1>>25)&0xFF,wmi_value.value2&(0xFFFFFF),(wmi_value.value2>>25)&0xFF);
		MessageBox(str,L"output to high");
	} 
	else
	{
		MessageBox(L"read value fail.");
		return;
	}

	//write,set out status to low
	value=(1<<24);
	if ( WMI_ERRR_CODE_SUCCESS != (res = SetDIOWMI(value,&wmi_value)) )
	{
		MessageBox(L"write value fail.");
		return;
	}
	//read,check set value
	value=0;
	if ( WMI_ERRR_CODE_SUCCESS == (res = SetDIOWMI(value,&wmi_value)) )
	{
		str.Format(L"InputStatus %x\r\ncountofDIO %d\r\nOutputStatus %x \r\ncountofDIO %d",wmi_value.value1&(0xFFFFFF),(wmi_value.value1>>25)&0xFF,wmi_value.value2&(0xFFFFFF),(wmi_value.value2>>25)&0xFF);
		MessageBox(str,L"output to Low");
	} 
	else
	{
		MessageBox(L"read value fail.");
		return;
	}
}

void CTestSDKDlg::OnBnClickedBtnWdt()
{
	// TODO: Add your control notification handler code here

	UINT32 maxWDTTimer = 255; //the maximum value is 255.
	ZeroMemory(&wmi_value,sizeof(WMI_VALUE));
	ISMMSDK_ERROR_CODE res = WMI_ERRR_CODE_SUCCESS;

	wmi_value.ID=2; //Get isSupport
	if ( WMI_ERRR_CODE_SUCCESS == (res = SetWTDWMI(&wmi_value)) )
	{
		if ( (0xFFFFFFFF != wmi_value.status) && (0 != wmi_value.status) )//support
			maxWDTTimer = wmi_value.status;
		else
		{
			if ( 0 == (wmi_value.status ? 0xFFFFFFFF:0) )//support
				maxWDTTimer = 255;
			else//wmi_value.status=0xFFFFFFFF means does not support.
				return;
		}

		//=============================================================================
		//<1> specify time reboot
		wmi_value.ID=0;
		wmi_value.value1=5;
		wmi_value.value2=0;
		if ( WMI_ERRR_CODE_SUCCESS != (res = SetWTDWMI(&wmi_value)) )
		{
			MessageBox(L"set wdt fail.");
			return;
		}
/*
		//=============================================================================
		//<2> specify time reset,keep don't reboot
		wmi_value.ID=1;
		wmi_value.value1=setTime;
		wmi_value.value2=0; //0-->second; 1-->minutes
		if ( WMI_ERRR_CODE_SUCCESS == (res = SetWTDWMI(&wmi_value)) )
		{
			//when time=time*70%,wdt reset.(70%-->suggestion value,this value you can change)
			SetTimer(TIMERID,setTime*100,NULL);
		}
		else
		{
			MessageBox(L"set wdt fail.");
			return;
		}

		//=============================================================================
		//<3> stop wdt
		wmi_value.ID=0;
		wmi_value.value1=0;
		wmi_value.value2=0;
		if ( WMI_ERRR_CODE_SUCCESS != (res = SetWTDWMI(&wmi_value)) )
		{
			MessageBox(L"set wdt fail.");
			return;
		}
*/
	} 
	else
	{
		MessageBox(L"set wdt fail.");
		return;
	}
}

void CTestSDKDlg::OnClose()
{
	// TODO: Add your message handler code here and/or call default

	WmiExit();

	CDialog::OnClose();
}

void CTestSDKDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default

	ISMMSDK_ERROR_CODE res = WMI_ERRR_CODE_SUCCESS;
	switch (nIDEvent)
	{
	case TIMERID:
		{
			wmi_value.ID=1;
			wmi_value.value1=setTime;
			wmi_value.value2=0;
			if ( WMI_ERRR_CODE_SUCCESS != (res = SetWTDWMI(&wmi_value)) )
			{
				KillTimer(TIMERID);
				MessageBox(L"set wdt fail.");
			}

			break;
		}
	case TIMERID+1:
		{
			//ֹһʱδWMI root/cimv2namespaceʹͻ˶Ͽ
			//Remote_PowerOff_RestartWMIʧ
			if ( WMI_ERRR_CODE_SUCCESS != (res = Remote_heart_package_SrvCimv2WMI()) )
			{
				KillTimer(TIMERID+1);
				MessageBox(L"remote connection root/cimv2 fail.");
			}
			break;
		}
	}

	CDialog::OnTimer(nIDEvent);
}

void CTestSDKDlg::OnBnClickedBtnPoweroff()
{
	// TODO: Add your control notification handler code here

	Remote_PowerOff_RestartWMI(POWEROFF);
}

void CTestSDKDlg::OnBnClickedBtnReboot()
{
	// TODO: Add your control notification handler code here

	Remote_PowerOff_RestartWMI(REBOOT);
	//ĿٲҪڳһĻ.
}

void CTestSDKDlg::OnBnClickedBtnPoweron()
{
	// TODO: Add your control notification handler code here

	//ĿMACַaabbccddeeff
	Remote_PowerOn(L"aabbccddeeff");
}
